/******************************************************************************
 * Copyright (C) 2018  Tadeus Prastowo <eus@member.fsf.org>                   *
 *                                            (GPG public key ID: 0x277B48A6) *
 *                                                                            *
 * This program is free software: you can redistribute it and/or modify       *
 * it under the terms of the GNU General Public License as published by       *
 * the Free Software Foundation, either version 3 of the License, or          *
 * (at your option) any later version.                                        *
 *                                                                            *
 * This program is distributed in the hope that it will be useful,            *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 * GNU General Public License for more details.                               *
 *                                                                            *
 * You should have received a copy of the GNU General Public License          *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.      *
 ******************************************************************************/

namespace tice {
  namespace v1 {
    
    template<typename arg__channel_type, arg__channel_type arg__initial_value>
    class Chan_inline_init {
      static_assert(std::is_object<arg__channel_type>::value,
                    "Channel type is not an object type (neither void nor reference type nor function type)");
      static_assert(!std::is_const<arg__channel_type>::value && !std::is_volatile<arg__channel_type>::value,
                    "Channel type cannot be cv-qualified (qualified with either const or volatile or both)");
    public:
      typedef arg__channel_type type;
      typedef std::integral_constant<arg__channel_type, arg__initial_value> initial_value;
    };

  };
};
